#ifndef __GLASSES_OBJECT_H__
#define __GLASSES_OBJECT_H__

#include <gnome.h>


#define TYPE_GLASSES_OBJECT   		(glasses_object_get_type ())
#define GLASSES_OBJECT(obj)			(GTK_CHECK_CAST ((obj), TYPE_GLASSES_OBJECT, GlassesObject))
#define GLASSES_OBJECT_CLASS(klass)	(GTK_CHECK_CLASS_CAST ((klass), TYPE_GLASSES_OBJECT, GlassesObjectClass))
#define IS_GLASSES_OBJECT(obj)		(GTK_CHECK_TYPE ((obj), TYPE_GLASSES_OBJECT))
#define IS_GLASSES_OBJECT_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), TYPE_GLASSES_OBJECT_CLASS))

typedef struct _ArgInfo ArgInfo;
struct _ArgInfo
{
	gchar *name;
	GtkType type;
	guint32 flags;
};

typedef struct _GlassesObject       GlassesObject;
typedef struct _GlassesObjectClass  GlassesObjectClass;

struct _GlassesObject
{
	GtkObject parent_instance;

	GlassesObject *parent;
	
	GtkType type;
	gchar *name;
	guint object_size;
	guint class_size;

	GList *children;
	GList *children_types;

	GList *signals;     /* GtkSignalQuerys */
	GList *arguments;   /* ArgInfos */
};

struct _GlassesObjectClass
{
	GtkObjectClass     parent_class;

	void (* child_added)         (GlassesObject *self, GlassesObject *child);
};


GtkType         glasses_object_get_type    (void);
GlassesObject*  glasses_object_new         (GtkType type,
											GlassesObject *parent);
gchar *			glasses_object_get_name    (GlassesObject *self);
void 			glasses_object_add_child   (GlassesObject *self,
											GtkType type);
void          	glasses_object_update      (GlassesObject *self);


#endif /* __GLASSES_OBJECT_H__ */
